/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "fxlib.h"
#include "TIMER_FX2.H"
#include "KeyScan.H"

//------------------------------------------------------------------------------

int FuncKeyDown()	// no key down : 0
{
	if ( *(volatile unsigned short*)0xFFFFFF80 != 0 ) 
	 return ( *((unsigned char*)0xA4000120) != 0xFF );		// SH3
	 return ( *((unsigned short*)0xA44b0008) != 0 );		// SH4A
}
//------------------------------------------------------------------------------
int KeyCheckAC(void)		// [AC]
{
//	int kcode1 = 0, kcode2 = 0, flag0 = 0;
//	short unused = 0;

//	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
//		if ( ( kcode1 == 1 ) && (kcode2 == 1 ) ) flag0=1; // [AC] is down
//	}
//	return flag0;

 	return ( KeyScanDown(KEYSC_AC) );
}

int KeyCheckEXE(void)		// [EXE]
{
//	int kcode1 = 0, kcode2 = 0, flag0 = 0;
//	short unused = 0;

//	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
//		if ( ( kcode1 == 3 ) && (kcode2 == 2 ) ) flag0=1; // [EXE] is down
//	}
//	return flag0;

 	return ( KeyScanDown(KEYSC_EXE) );

}

int KeyCheckPlusMinus(void)	// (-)
{
//	int kcode1 = 0, kcode2 = 0, flag0 = 0;
//	short unused = 0;

//	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
//		if ( ( kcode1 == 4 ) && (kcode2 == 2 ) ) flag0=1; // [(-)] is down
//	}
//	return flag0;

 	return ( KeyScanDown(KEYSC_PMINUS) );

}



//------------------------------------------------------------------------------
void plot_on_VRAM(x, y)
{
		Bdisp_SetPoint_VRAM(x, 63-y, 1);
}

void plot_on_DD(x, y)
{
		Bdisp_SetPoint_VRAM(x, 63-y, 1);
		Bdisp_PutDisp_DD();
}

//------------------------------------------------------------------------------
// ԕ\ɂɂ́A//** ̃RgAEgO
void markout_gr(int skip)
{
	int j=0, s,t;
	int x,y;
	char buffer[21];
	unsigned int key;

	Bdisp_AllClr_DDVRAM();
//	PrintMini(3,7,(unsigned char*)" AC:Exit    ",0);
	
	while ( FuncKeyDown() );
	
	Bdisp_PutDisp_DD();

	start_timer();

	for (y=0; y<=31 ; y++) {
		for (x=1; x<=127; x++) {
			plot_on_VRAM(x, y);

			j++;
			if ( j>=skip ) { j=0;
//**				t=RTC_GetTicks()-s;
//**				sprintf(buffer, "t=%5.2fs", (double)t/128);	PrintMini(90,21,(unsigned char*)buffer,0);
					Bdisp_PutDisp_DD();
//				if ( KeyCheckPlusMinus() ) {
//					PrintMini(1,1,(unsigned char*)"  ",0);	PrintMini(3,1,(unsigned char*)"EXE:Start",0);
//					while ( 1 )  { GetKey(&key);
//						if ( key == KEY_CTRL_EXE  ) break;		// [EXE]
//						if ( key == KEY_CTRL_AC   ) return;		// [AC]
//					}	
//**					PrintMini(1,1,(unsigned char*)" (-):Stop    ",0);
//**					s=RTC_GetTicks()-t;
//				}	
//				if ( KeyCheckAC() ) return;
			}
		}
	}
	t=get_timer();
	sprintf(buffer, "t=%5.3fs", (double)t/1000);	PrintMini(90,21,(unsigned char*)buffer,0);
	PrintMini(3,1,(unsigned char*)"Completed",0);
	PrintMini(3,7,(unsigned char*)" AC:Exit    ",0);
	Bdisp_PutDisp_DD();
	while ( 1 )  { GetKey(&key);
		if ( key == KEY_CTRL_AC   ) return;		// [AC]
	}
}

//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	unsigned int key;
	int cont=1;
	int mode=0;	// mode=0: LCD transfer check, mode=1: key scan check

	while( cont ) {
		Bdisp_AllClr_DDVRAM();
		locate(1,1);Print((unsigned char*)"F1:MarkOut Dot");
		locate(1,2);Print((unsigned char*)"F2:MarkOut Line");
		locate(1,3);Print((unsigned char*)"F3:MarkOut Thick Line");
		
		GetKey(&key);
		switch (key) {
//			case KEY_CTRL_EXIT:
//				cont=0;
//				break;
				
			case KEY_CTRL_F1:
				markout_gr(1);
				break;
			case KEY_CTRL_F2:
				markout_gr(127);
				break;
			case KEY_CTRL_F3:
				markout_gr(254);
				break;
				
			default:
				break;
		}
	}

	return 1;
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

